@echo off
REM frs_setlogsev Computername severity_level [line_count  [logfile_count]]

SETLOCAL ENABLEEXTENSIONS  ENABLEDELAYEDEXPANSION

if "%1"=="" goto :USAGE
if "%2"=="" goto :ARG_ERROR


echo HKEY_LOCAL_MACHINE\system\currentcontrolset\services\NtFrs [17 1]> frs_setlogsev.ini
echo     Parameters [17 1]>> frs_setlogsev.ini


if /I "%2"=="default" (
    echo         Debug Log Severity = REG_DWORD 2 >> frs_setlogsev.ini
    echo         Debug Maximum Log Messages = REG_DWORD 20000>> frs_setlogsev.ini
    echo         Debug Log Files = REG_DWORD 5 >> frs_setlogsev.ini
) ELSE (
    set /a sev_level=%2
    if  ERRORLEVEL 1  goto :ARG_ERROR
    if !sev_level! LSS 0  goto :ARG_ERROR

    if %2 LEQ 5 (
        if "%3"=="" (
            set line_count=50000
        ) else (
            set /a line_count=%3
            if  ERRORLEVEL 1  goto :ARG_ERROR
            if !line_count! LEQ 0  goto :ARG_ERROR
        )
        
        if "%4"=="" (
            set logfile_count=16
        ) else (
            set /a logfile_count=%4
            if  ERRORLEVEL 1  goto :ARG_ERROR
            if !logfile_count! LEQ 0  goto :ARG_ERROR
        )

        echo         Debug Log Severity = REG_DWORD %2 >> frs_setlogsev.ini
        echo         Debug Maximum Log Messages = REG_DWORD !line_count! >> frs_setlogsev.ini
        echo         Debug Log Files = REG_DWORD !logfile_count! >> frs_setlogsev.ini
    ) ELSE (
        goto :ARG_ERROR
    )
)

REM type frs_setlogsev.ini

ping -n 1 -w 3000 %1 > ping.tmp
findstr /i /r /c:"unreachable" /c:"^request timed out"  /c:"unknown host"  ping.tmp >nul: 2>nul:
if NOT ERRORLEVEL 1 (

    echo  ----- %1 unreachable with ping.  Skipping.
) else (

    if /I "%2"=="default" (
        echo Setting FRS log severity level to default on %1
    ) ELSE (
        echo Setting FRS log severity level to %2, line_count to !line_count!, logfile_count to !logfile_count! on %1
    )

    regini  -m \\%1  frs_setlogsev.ini
    if  ERRORLEVEL 1  (
        echo  ----- regini failed to set log severity on computer \\%1
        del ping.tmp   1>nul: 2>nul:
        del frs_setlogsev.ini    1>nul: 2>nul:
        goto :USAGE
    )
)

echo.

del ping.tmp   1>nul: 2>nul:
del frs_setlogsev.ini    1>nul: 2>nul:

goto :QUIT

:ARG_ERROR
echo.
echo Error - Invalid or missing parameter.
echo Usage:


:USAGE
echo.
echo frs_setlogsev  computername  severity_level [line_count  [logfile_count]]
echo    where severity_level is 0 to 5 or "default"
echo    line_count is optional and is the approx number of lines written to a single logfile
echo    logfile_count is optional and is the number of log files kept as history.
echo    if "default" is specified then line_count and logfile_count parameters are ignored.
echo.
echo e.g.  frs_setlogsev xyz.corp.microsoft.com  4
echo e.g.  frs_setlogsev xyz.corp.microsoft.com  3  50000  25
echo e.g.  frs_setlogsev abc.corp.microsoft.com  default
echo.



:QUIT
